diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDistributionCreationMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDistributionCreationMapper.java
index 0f02a4dc11..3985da1798 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDistributionCreationMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/DbImportDistributionCreationMapper.java
@@ -1,73 +1,74 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping;
-
-import java.sql.ResultSet;
-import java.sql.SQLException;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.DbImportStateBase;
-import eu.etaxonomy.cdm.model.description.Distribution;
-import eu.etaxonomy.cdm.model.description.PresenceAbsenceTerm;
-
-/**
- * This Mapper creates a distribution and adds it to a taxon.
- * @author a.mueller
- * @since 11.03.2010
- */
-public class DbImportDistributionCreationMapper<STATE extends DbImportStateBase<?,?>>
-        extends DbImportDescriptionElementCreationMapperBase<Distribution, DbImportStateBase<?,?>> {
-
-	@SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(DbImportDistributionCreationMapper.class);
-
-//******************************** FACTORY METHOD ***************************************************/
-
-	/**
-	 * Creates a Distribution and adds it to the description of a taxon.
-	 * @param dbIdAttribute
-	 * @param objectToCreateNamespace
-	 * @param dbTaxonFkAttribute
-	 * @param taxonNamespace
-	 * @return
-	 */
-	public static DbImportDistributionCreationMapper<?> NewInstance(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace){
-		PresenceAbsenceTerm status = null;
-		return new DbImportDistributionCreationMapper<>(dbIdAttribute, objectToCreateNamespace, dbTaxonFkAttribute, taxonNamespace, status);
-	}
-
-	/**
-	 * Creates a Distribution with status <code>status</code> and adds it to the description of a taxon.
-	 */
-	public static DbImportDistributionCreationMapper<?> NewFixedStatusInstance(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace, PresenceAbsenceTerm status){
-		return new DbImportDistributionCreationMapper<>(dbIdAttribute, objectToCreateNamespace, dbTaxonFkAttribute, taxonNamespace, status);
-	}
-
-//******************************* ATTRIBUTES ***************************************/
-
-	protected PresenceAbsenceTerm status;
-
-//********************************* CONSTRUCTOR ****************************************/
-
-	protected DbImportDistributionCreationMapper(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace, PresenceAbsenceTerm status) {
-		super(dbIdAttribute, objectToCreateNamespace, dbTaxonFkAttribute, taxonNamespace);
-		this.status = status;
-	}
-
-//************************************ METHODS *******************************************/
-
-	@Override
-	protected Distribution createObject(ResultSet rs) throws SQLException {
-		Distribution distribution = Distribution.NewInstance(null, null);
-		distribution.setStatus(status);
-		return distribution;
-	}
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.DbImportStateBase;
+import eu.etaxonomy.cdm.model.description.Distribution;
+import eu.etaxonomy.cdm.model.description.PresenceAbsenceTerm;
+
+/**
+ * This Mapper creates a distribution and adds it to a taxon.
+ * @author a.mueller
+ * @since 11.03.2010
+ */
+public class DbImportDistributionCreationMapper<STATE extends DbImportStateBase<?,?>>
+        extends DbImportDescriptionElementCreationMapperBase<Distribution, DbImportStateBase<?,?>> {
+
+	@SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
+
+//******************************** FACTORY METHOD ***************************************************/
+
+	/**
+	 * Creates a Distribution and adds it to the description of a taxon.
+	 * @param dbIdAttribute
+	 * @param objectToCreateNamespace
+	 * @param dbTaxonFkAttribute
+	 * @param taxonNamespace
+	 * @return
+	 */
+	public static DbImportDistributionCreationMapper<?> NewInstance(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace){
+		PresenceAbsenceTerm status = null;
+		return new DbImportDistributionCreationMapper<>(dbIdAttribute, objectToCreateNamespace, dbTaxonFkAttribute, taxonNamespace, status);
+	}
+
+	/**
+	 * Creates a Distribution with status <code>status</code> and adds it to the description of a taxon.
+	 */
+	public static DbImportDistributionCreationMapper<?> NewFixedStatusInstance(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace, PresenceAbsenceTerm status){
+		return new DbImportDistributionCreationMapper<>(dbIdAttribute, objectToCreateNamespace, dbTaxonFkAttribute, taxonNamespace, status);
+	}
+
+//******************************* ATTRIBUTES ***************************************/
+
+	protected PresenceAbsenceTerm status;
+
+//********************************* CONSTRUCTOR ****************************************/
+
+	protected DbImportDistributionCreationMapper(String dbIdAttribute, String objectToCreateNamespace, String dbTaxonFkAttribute, String taxonNamespace, PresenceAbsenceTerm status) {
+		super(dbIdAttribute, objectToCreateNamespace, dbTaxonFkAttribute, taxonNamespace);
+		this.status = status;
+	}
+
+//************************************ METHODS *******************************************/
+
+	@Override
+	protected Distribution createObject(ResultSet rs) throws SQLException {
+		Distribution distribution = Distribution.NewInstance(null, null);
+		distribution.setStatus(status);
+		return distribution;
+	}
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmOneToManyMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmOneToManyMapper.java
index 0338da9426..54b9e985c6 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmOneToManyMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmOneToManyMapper.java
@@ -1,110 +1,111 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping.berlinModel;
-
-import java.util.ArrayList;
-import java.util.List;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.mapping.CdmSingleAttributeMapperBase;
-import eu.etaxonomy.cdm.io.common.mapping.MultipleAttributeMapperBase;
-import eu.etaxonomy.cdm.model.common.CdmBase;
-
-/**
- * @author a.mueller
- * @since 20.03.2008
- * @version 1.0
- */
-public class CdmOneToManyMapper<ONE extends CdmBase, MANY extends CdmBase, SINGLE_MAPPER extends CdmSingleAttributeMapperBase> extends MultipleAttributeMapperBase<SINGLE_MAPPER> {
-	@SuppressWarnings("unused")
-	private static Logger logger = LogManager.getLogger(CdmOneToManyMapper.class);
-
-	private Class<MANY> manyClass;
-	private Class<ONE> oneClass;
-	private String singleAttributeName;
-
-	public CdmOneToManyMapper(Class<ONE> oneClass, Class<MANY> manyClass, String singleAttributeName, SINGLE_MAPPER[] singleAttributesMappers) {
-		if (singleAttributesMappers == null){
-			throw new NullPointerException("singleAttributesMapper and cdmAttributeStrings must not be null");
-		}
-		for (SINGLE_MAPPER singleMapper : singleAttributesMappers){
-			singleMappers.add(singleMapper);
-		}
-		this.manyClass = manyClass;
-		this.oneClass = oneClass;
-		this.singleAttributeName = singleAttributeName;
-	}
-
-//	@Override
-//	public Set<String> getSourceAttributes(){
-//		Set<String> result = new HashSet<>();
-//		result.addAll(getSourceAttributeList());
-//		return result;
-//	}
-
-	@Override
-	public List<String> getSourceAttributeList(){
-		List<String> result = new ArrayList<String>();
-		for (SINGLE_MAPPER singleMapper : singleMappers){
-			result.add(singleMapper.getSourceAttribute());
-		}
-		return result;
-	}
-
-//	@Override
-//	public Set<String> getDestinationAttributes(){
-//		Set<String> result = new HashSet<>();
-//		result.addAll(getDestinationAttributeList());
-//		return result;
-//	}
-
-	@Override
-	public List<String> getDestinationAttributeList(){
-		List<String> result = new ArrayList<String>();
-		for (SINGLE_MAPPER singleMapper : singleMappers){
-			result.add(singleMapper.getDestinationAttribute());
-		}
-		return result;
-	}
-
-
-	public Class<MANY> getManyClass(){
-		return manyClass;
-	}
-
-	public Class<ONE> getOneClass(){
-		return oneClass;
-	}
-
-	public String getDestinationAttribute(String sourceAttribute){
-		if (sourceAttribute == null){
-			return null;
-		}
-		for (SINGLE_MAPPER singleMapper : singleMappers){
-			if (sourceAttribute.equals(singleMapper.getSourceAttribute())){
-				return singleMapper.getDestinationAttribute();
-			}
-		}
-		return null;
-	}
-
-	public List<SINGLE_MAPPER> getSingleMappers(){
-		return singleMappers;
-	}
-
-	/**
-	 * @return the singleAttributeName
-	 */
-	public String getSingleAttributeName() {
-		return singleAttributeName;
-	}
-
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping.berlinModel;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.mapping.CdmSingleAttributeMapperBase;
+import eu.etaxonomy.cdm.io.common.mapping.MultipleAttributeMapperBase;
+import eu.etaxonomy.cdm.model.common.CdmBase;
+
+/**
+ * @author a.mueller
+ * @since 20.03.2008
+ */
+public class CdmOneToManyMapper<ONE extends CdmBase, MANY extends CdmBase, SINGLE_MAPPER extends CdmSingleAttributeMapperBase> extends MultipleAttributeMapperBase<SINGLE_MAPPER> {
+
+    @SuppressWarnings("unused")
+	private static Logger logger = LogManager.getLogger();
+
+	private Class<MANY> manyClass;
+	private Class<ONE> oneClass;
+	private String singleAttributeName;
+
+	public CdmOneToManyMapper(Class<ONE> oneClass, Class<MANY> manyClass, String singleAttributeName, SINGLE_MAPPER[] singleAttributesMappers) {
+		if (singleAttributesMappers == null){
+			throw new NullPointerException("singleAttributesMapper and cdmAttributeStrings must not be null");
+		}
+		for (SINGLE_MAPPER singleMapper : singleAttributesMappers){
+			singleMappers.add(singleMapper);
+		}
+		this.manyClass = manyClass;
+		this.oneClass = oneClass;
+		this.singleAttributeName = singleAttributeName;
+	}
+
+//	@Override
+//	public Set<String> getSourceAttributes(){
+//		Set<String> result = new HashSet<>();
+//		result.addAll(getSourceAttributeList());
+//		return result;
+//	}
+
+	@Override
+	public List<String> getSourceAttributeList(){
+		List<String> result = new ArrayList<String>();
+		for (SINGLE_MAPPER singleMapper : singleMappers){
+			result.add(singleMapper.getSourceAttribute());
+		}
+		return result;
+	}
+
+//	@Override
+//	public Set<String> getDestinationAttributes(){
+//		Set<String> result = new HashSet<>();
+//		result.addAll(getDestinationAttributeList());
+//		return result;
+//	}
+
+	@Override
+	public List<String> getDestinationAttributeList(){
+		List<String> result = new ArrayList<String>();
+		for (SINGLE_MAPPER singleMapper : singleMappers){
+			result.add(singleMapper.getDestinationAttribute());
+		}
+		return result;
+	}
+
+
+	public Class<MANY> getManyClass(){
+		return manyClass;
+	}
+
+	public Class<ONE> getOneClass(){
+		return oneClass;
+	}
+
+	public String getDestinationAttribute(String sourceAttribute){
+		if (sourceAttribute == null){
+			return null;
+		}
+		for (SINGLE_MAPPER singleMapper : singleMappers){
+			if (sourceAttribute.equals(singleMapper.getSourceAttribute())){
+				return singleMapper.getDestinationAttribute();
+			}
+		}
+		return null;
+	}
+
+	public List<SINGLE_MAPPER> getSingleMappers(){
+		return singleMappers;
+	}
+
+	/**
+	 * @return the singleAttributeName
+	 */
+	public String getSingleAttributeName() {
+		return singleAttributeName;
+	}
+
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmStringMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmStringMapper.java
index e635d8380e..b3feeb3817 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmStringMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/berlinModel/CdmStringMapper.java
@@ -1,37 +1,34 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy 
-* http://www.e-taxonomy.eu
-* 
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping.berlinModel;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.mapping.CdmSingleAttributeMapperBase;
-
-/**
- * @author a.mueller
- * @since 20.03.2008
- * @version 1.0
- */
-public class CdmStringMapper extends CdmSingleAttributeMapperBase {
-	@SuppressWarnings("unused")
-	private static Logger logger = LogManager.getLogger(CdmStringMapper.class);
-	
-	/**
-	 * @param dbValue
-	 * @param cdmValue
-	 */
-	public CdmStringMapper(String dbAttributeString, String cdmAttributeString) {
-		super(dbAttributeString, cdmAttributeString);
-	}
-	
-	public Class<String> getTypeClass(){
-		return String.class;
-	}
-	
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping.berlinModel;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.mapping.CdmSingleAttributeMapperBase;
+
+/**
+ * @author a.mueller
+ * @since 20.03.2008
+ */
+public class CdmStringMapper extends CdmSingleAttributeMapperBase {
+
+	@SuppressWarnings("unused")
+	private static Logger logger = LogManager.getLogger();
+
+	public CdmStringMapper(String dbAttributeString, String cdmAttributeString) {
+		super(dbAttributeString, cdmAttributeString);
+	}
+
+	@Override
+    public Class<String> getTypeClass(){
+		return String.class;
+	}
+}
\ No newline at end of file
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/CdmDbExportMapping.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/CdmDbExportMapping.java
index 4821b490e1..68181ef0c0 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/CdmDbExportMapping.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/CdmDbExportMapping.java
@@ -1,146 +1,147 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping.out;
-
-import java.sql.PreparedStatement;
-import java.sql.SQLException;
-import java.util.ArrayList;
-import java.util.List;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.DbExportConfiguratorBase;
-import eu.etaxonomy.cdm.io.common.DbExportStateBase;
-import eu.etaxonomy.cdm.io.common.Source;
-import eu.etaxonomy.cdm.io.common.mapping.CdmIoMapping;
-import eu.etaxonomy.cdm.io.common.mapping.CdmMapperBase;
-import eu.etaxonomy.cdm.model.common.CdmBase;
-
-/**
- * @author a.mueller
- * @since 12.05.2009
- */
-public class CdmDbExportMapping<STATE extends DbExportStateBase<CONFIG, TRANSFORM>, CONFIG extends DbExportConfiguratorBase<STATE, TRANSFORM, Source>, TRANSFORM extends IExportTransformer>
-        extends CdmIoMapping {
-
-    private static final Logger logger = LogManager.getLogger(CdmDbExportMapping.class);
-
-	private PreparedStatement preparedStatement;
-	private String dbTableName;
-	private List<CollectionExportMapping<STATE,CONFIG, TRANSFORM>> collectionMappingList = new ArrayList<>();
-
-	public CdmDbExportMapping(String tableName){
-		this.dbTableName = tableName;
-	}
-
-	public boolean initialize(STATE state) throws SQLException{
-		CONFIG config = state.getConfig();
-		Source db = config.getDestination();
-
-		try {
-			IndexCounter index;
-			String strPreparedStatement = prepareStatement();
-			logger.debug(strPreparedStatement);
-			this.preparedStatement = db.getConnection().prepareStatement(strPreparedStatement);
-			index = new IndexCounter(1);
-
-			for (CdmMapperBase mapper : this.mapperList){
-				if (mapper instanceof IDbExportMapper){
-					IDbExportMapper<DbExportStateBase<?,TRANSFORM>,TRANSFORM> dbMapper = (IDbExportMapper)mapper;
-					dbMapper.initialize(preparedStatement, index, state, dbTableName);
-				}else{
-					logger.warn("mapper "+mapper.toString() + "," + mapper.getClass().getName() +" is not of type " + IDbExportMapper.class.getSimpleName());
-				}
-			}
-			for (CollectionExportMapping<STATE,CONFIG, TRANSFORM> collectionMapping : this.collectionMappingList ){
-				collectionMapping.initialize(state);
-			}
-			return true;
-		} catch (SQLException e) {
-			logger.warn("SQL Exception");
-			throw e;
-		}
-	}
-
-	public boolean invoke(CdmBase cdmBase){
-		try {
-			boolean result = true;
-			for (CdmMapperBase mapper : this.mapperList){
-				if (mapper instanceof ObjectChangeMapper){
-					ObjectChangeMapper changeMapper = (ObjectChangeMapper)mapper;
-					cdmBase = changeMapper.getNewObject(cdmBase);
-				}else if (mapper instanceof IDbExportMapper){
-					IDbExportMapper<DbExportStateBase<?,TRANSFORM>, TRANSFORM> dbMapper = (IDbExportMapper)mapper;
-					try {
-						result &= dbMapper.invoke(cdmBase);
-					} catch (Exception e) {
-						result = false;
-						logger.error("Error occurred in mapping.invoke");
-						e.printStackTrace();
-						continue;
-					}
-				}else {
-					logger.warn("mapper " + mapper.toString() + "is not of required type " + IDbExportMapper.class.getSimpleName());
-				}
-			}
-			int count = preparedStatement.executeUpdate();
-			if (logger.isDebugEnabled()) {
-                logger.debug("Number of rows affected: " + count);
-            }
-			for (CollectionExportMapping<STATE,CONFIG, TRANSFORM> collectionMapping : this.collectionMappingList ){
-				result &= collectionMapping.invoke(cdmBase);
-			}
-			return result;
-		} catch(Exception e){
-			e.printStackTrace();
-			logger.error(e.getMessage() + ": " + cdmBase.toString());
-			return false;
-		}
-	}
-
-	public void addCollectionMapping(CollectionExportMapping<STATE,CONFIG, TRANSFORM> collectionMapping){
-		this.collectionMappingList.add(collectionMapping);
-	}
-
-	protected String prepareStatement(){
-		String sqlInsert = "INSERT INTO " + getDbTableName() + " (";
-		String sqlValues = ") VALUES(";
-		String sqlEnd = ")";
-		String attributes = "";
-		String values = "";
-		for (String attribute : this.getDestinationAttributeList()){
-			attributes +=  "," + attribute;
-			values += ",?";
-		}
-		attributes = attributes.substring(1); //delete first ','
-		values = values.substring(1); //delete first ','
-		String result = sqlInsert + attributes + sqlValues + values + sqlEnd;
-		return result;
-	}
-
-	public String getDbTableName() {
-		return dbTableName;
-	}
-	public void setDbTableName(String dbTableName) {
-		this.dbTableName = dbTableName;
-	}
-
-	protected PreparedStatement getPreparedStatement() {
-		return preparedStatement;
-	}
-	protected void setPreparedStatement(PreparedStatement preparedStatement) {
-		this.preparedStatement = preparedStatement;
-	}
-
-//	protected List<CdmAttributeMapperBase> getAttributeMapperList(){
-//		List<CdmAttributeMapperBase> list = this.mapperList;
-//		return list;
-//	}
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping.out;
+
+import java.sql.PreparedStatement;
+import java.sql.SQLException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.DbExportConfiguratorBase;
+import eu.etaxonomy.cdm.io.common.DbExportStateBase;
+import eu.etaxonomy.cdm.io.common.Source;
+import eu.etaxonomy.cdm.io.common.mapping.CdmIoMapping;
+import eu.etaxonomy.cdm.io.common.mapping.CdmMapperBase;
+import eu.etaxonomy.cdm.model.common.CdmBase;
+
+/**
+ * @author a.mueller
+ * @since 12.05.2009
+ */
+public class CdmDbExportMapping<STATE extends DbExportStateBase<CONFIG, TRANSFORM>, CONFIG extends DbExportConfiguratorBase<STATE, TRANSFORM, Source>, TRANSFORM extends IExportTransformer>
+        extends CdmIoMapping {
+
+    private static final Logger logger = LogManager.getLogger();
+
+	private PreparedStatement preparedStatement;
+	private String dbTableName;
+	private List<CollectionExportMapping<STATE,CONFIG, TRANSFORM>> collectionMappingList = new ArrayList<>();
+
+	public CdmDbExportMapping(String tableName){
+		this.dbTableName = tableName;
+	}
+
+	public boolean initialize(STATE state) throws SQLException{
+		CONFIG config = state.getConfig();
+		Source db = config.getDestination();
+
+		try {
+			IndexCounter index;
+			String strPreparedStatement = prepareStatement();
+			logger.debug(strPreparedStatement);
+			this.preparedStatement = db.getConnection().prepareStatement(strPreparedStatement);
+			index = new IndexCounter(1);
+
+			for (CdmMapperBase mapper : this.mapperList){
+				if (mapper instanceof IDbExportMapper){
+					IDbExportMapper<DbExportStateBase<?,TRANSFORM>,TRANSFORM> dbMapper = (IDbExportMapper)mapper;
+					dbMapper.initialize(preparedStatement, index, state, dbTableName);
+				}else{
+					logger.warn("mapper "+mapper.toString() + "," + mapper.getClass().getName() +" is not of type " + IDbExportMapper.class.getSimpleName());
+				}
+			}
+			for (CollectionExportMapping<STATE,CONFIG, TRANSFORM> collectionMapping : this.collectionMappingList ){
+				collectionMapping.initialize(state);
+			}
+			return true;
+		} catch (SQLException e) {
+			logger.warn("SQL Exception");
+			throw e;
+		}
+	}
+
+	public boolean invoke(CdmBase cdmBase){
+		try {
+			boolean result = true;
+			for (CdmMapperBase mapper : this.mapperList){
+				if (mapper instanceof ObjectChangeMapper){
+					ObjectChangeMapper changeMapper = (ObjectChangeMapper)mapper;
+					cdmBase = changeMapper.getNewObject(cdmBase);
+				}else if (mapper instanceof IDbExportMapper){
+					IDbExportMapper<DbExportStateBase<?,TRANSFORM>, TRANSFORM> dbMapper = (IDbExportMapper)mapper;
+					try {
+						result &= dbMapper.invoke(cdmBase);
+					} catch (Exception e) {
+						result = false;
+						logger.error("Error occurred in mapping.invoke");
+						e.printStackTrace();
+						continue;
+					}
+				}else {
+					logger.warn("mapper " + mapper.toString() + "is not of required type " + IDbExportMapper.class.getSimpleName());
+				}
+			}
+			int count = preparedStatement.executeUpdate();
+			if (logger.isDebugEnabled()) {
+                logger.debug("Number of rows affected: " + count);
+            }
+			for (CollectionExportMapping<STATE,CONFIG, TRANSFORM> collectionMapping : this.collectionMappingList ){
+				result &= collectionMapping.invoke(cdmBase);
+			}
+			return result;
+		} catch(Exception e){
+			e.printStackTrace();
+			logger.error(e.getMessage() + ": " + cdmBase.toString());
+			return false;
+		}
+	}
+
+	public void addCollectionMapping(CollectionExportMapping<STATE,CONFIG, TRANSFORM> collectionMapping){
+		this.collectionMappingList.add(collectionMapping);
+	}
+
+	protected String prepareStatement(){
+		String sqlInsert = "INSERT INTO " + getDbTableName() + " (";
+		String sqlValues = ") VALUES(";
+		String sqlEnd = ")";
+		String attributes = "";
+		String values = "";
+		for (String attribute : this.getDestinationAttributeList()){
+			attributes +=  "," + attribute;
+			values += ",?";
+		}
+		attributes = attributes.substring(1); //delete first ','
+		values = values.substring(1); //delete first ','
+		String result = sqlInsert + attributes + sqlValues + values + sqlEnd;
+		return result;
+	}
+
+	public String getDbTableName() {
+		return dbTableName;
+	}
+	public void setDbTableName(String dbTableName) {
+		this.dbTableName = dbTableName;
+	}
+
+	protected PreparedStatement getPreparedStatement() {
+		return preparedStatement;
+	}
+	protected void setPreparedStatement(PreparedStatement preparedStatement) {
+		this.preparedStatement = preparedStatement;
+	}
+
+//	protected List<CdmAttributeMapperBase> getAttributeMapperList(){
+//		List<CdmAttributeMapperBase> list = this.mapperList;
+//		return list;
+//	}
+}
